$('.SlideshowComponent').component({

    // Nodes
    $slides: null,

    // Properties
    currentSlideIndex: 0,
    autoplay: false,

    /**
     * Bind nodes
     */
    nodes: function() {
        this.$slides = this.$element.find('.SlideshowComponent_slide');
        this.$controller = this.$element.find('.SlideshowComponent_controller');
    },

    /**
     * Bind events
     */
    events: function() {
        this.$controller.on('previous', function() {
            this.previousSlide();
        }.bind(this));

        this.$controller.on('next', function() {
            this.nextSlide();
        }.bind(this));
    },

    /**
     * Initialize
     */
    init: function() {
        this.autoplay = !! this.$element.data('slideshow-autoplay');
        this.showSlide(this.currentSlideIndex);

        if( this.autoplay ){
            this.play();
        }
    },

    /**
     * Play
     */
    play: function() {
        setTimeout(function() {
            this.nextSlide();
            this.play();
        }.bind(this), 1000);
    },

    /**
     * Show next slide
     */
    nextSlide : function() {
        this.currentSlideIndex = (this.currentSlideIndex + 1) % this.$slides.length;
        this.showSlide(this.currentSlideIndex);
    },


    previousSlide: function() {
        this.currentSlideIndex = (this.currentSlideIndex + this.$slides.length - 1) % this.$slides.length;
        this.showSlide(this.currentSlideIndex);
    },

    /**
     * Show one slide
     * @param index
     */
    showSlide: function(index) {
        this.$slides.hide();
        $(this.$slides[index]).show();
    },
});





