(function($){
    $.fn.component = function(component) {

        return this.each(function(index, element) {
            var instance = $.extend(true, {}, component);
            instance.$element = $(element);
            instance.$$index = index;
            callIfDefined(instance,'nodes');
            callIfDefined(instance,'events');
            callIfDefined(instance,'init');
        });

        /**
         * Call method on object if defined
         * @param object
         * @param method
         * @returns {*}
         */
        function callIfDefined(object, method) {
            if( ! object.hasOwnProperty(method)) {
                return false;
            }

            return object[method]();
        }
    };
})(jQuery);